import re

from si_tests import settings


def get_cluster_kubeconfig(remote, cluster_name, provider):
    kubeconfig_output = "kubeconfig"
    kubeconfig_path = settings.KUBECONFIG_KIND_PATH
    if provider == settings.BAREMETAL_PROVIDER_NAME:
        kubeconfig_path = f"{settings.KAAS_BOOTSTRAP_TARGET_DIR}/{settings.KUBECONFIG_KIND_PATH}"
        kubeconfig_output = f"{settings.KAAS_BOOTSTRAP_TARGET_DIR}/{kubeconfig_output}"
    try:
        result = remote.execute(
            command=f"./{settings.KAAS_BOOTSTRAP_TARGET_DIR}/container-cloud get cluster-kubeconfig " +
            f"--cluster-name {cluster_name} " +
            f"--kubeconfig-output {kubeconfig_output} " +
            f"--kubeconfig {kubeconfig_path}",
            verbose=True, timeout=30)
        return result and result.exit_code == 0
    except Exception:
        return False


def is_bootstrap_version_dev(version):
    rx_dev = r'\d+\.\d+\.\d+-\d+-[0-9a-f]+'
    return re.match(rx_dev, version)


def extract_clean_kaasrelease_version(kr_name):
    rx_clean = r'\d+.\d+.\d+'
    return re.search(rx_clean, kr_name).group(0)
